#lang racket

(require "utilities.rkt")

(define assign #hash())

; Fill in your code here. Should finally define a function
; called dpll which returns true or false. Should additionally
; store the satisfying assignment in the variable assign.
(define (tree-list t1)
  (define (or-conv ot1)
    (match ot1
      [(Var lit) (list lit)]
      [(Not e) (list (* -1 (Var-lit e)))]
      [(Or x y) (let* ([y-list (or-conv y)])
                  (match x 
                    [(Var lit) (cons lit y-list) ]
                    [(Not e) (cons (* -1 (Var-lit e)) y-list)]))]))
  (cond [(And? t1) (let* ([x (And-x t1)]
                          [y (And-y t1)]
                          [o-c-x (or-conv x)])
                     (cons o-c-x (tree-list y)))]
        [else (list (or-conv t1))]))

(define (dpll f)
  (set! assign #hash())
  (let* ([t-l-f (tree-list f) ] )  
    (define xyz (remove-duplicates (append* t-l-f)))   
    (define assign-my #hash())
    
    
    (define (unit-prop-rem l x)
      (define (unit-prop-rem-h l)
        (cond [(null? l) '()]
              [else (let* ([carl (car l)])
                      (cond [(member x carl) (unit-prop-rem-h (cdr l))]
                            [(member (* -1 x) carl) (cons (remove (* -1 x) carl) (unit-prop-rem-h (cdr l) ))]
                            [else (cons carl (unit-prop-rem-h (cdr l) ))]))]))
      (let* ([rough (unit-prop-rem-h l)])
        (cond [(member '() rough ) (cons '() (remove* (list '()) rough))]
              [else rough])))
    
    (define (lit-elim l x)
      (cond  [(null? l) '()]
             [else (let* ([carl (car l)])
                     (if (member x carl) (lit-elim (cdr l) x) (cons carl (lit-elim (cdr l) x))))]))
    
    (define (basic-step l assignt xyzt )
  ;    (display "l: ") (displayln l) (newline) (displayln xyzt) (displayln assignt) 
      (define (search-single l1)
        (cond [(null? l1) #f]
              [else (let* ([carl1 (car l1)])
                      (if (null? (cdr carl1)) (car carl1) (search-single (cdr l1))))]))
      (define (search-both t)
        (cond[(null? t) #f]
             [else (let* ([cart (car t)])
                     (if (member (* -1 cart) t) (search-both (remove* (list cart (* -1 cart)) t)) cart))]))  
      
      (define (b-s-h l b1 b2)
        (cond[(null? l) (list #t assignt xyzt)]
             [(member '() l) (list #f #f)]
             [b1 (let* ([s-s (search-single l)])
                   (if s-s (begin (set! xyzt (remove* (list s-s (* -1 s-s)) xyzt)) 
                                  (if (> s-s 0) (set! assignt (dict-set assignt s-s #t)) (set! assignt (dict-set assignt (* -1 s-s) #f)))
                                  (b-s-h (unit-prop-rem l s-s) #t #t)) (b-s-h l #f #t)))]
             [b2 (let* ([s-b (search-both xyzt)])
                   (if s-b (begin (set! xyzt (remove s-b xyzt))
                                  (if (> s-b 0) (set! assignt (dict-set assignt s-b #t)) (set! assignt (dict-set assignt (* -1 s-b) #f)))
                                  (b-s-h (lit-elim l s-b) #f #t)) (b-s-h l  #f #f)))]
             [else (list (list l #f) assignt xyzt)]))
      (b-s-h l #t #t))
    
    
    
    (define (dpll-h l assign-old xyz-old x)
      (define assign2 (dict-set assign-old x #t))
      (define assign3 (dict-set assign-old x #f))
      (define xyz2 xyz-old)
      (define xyz3 xyz-old)
      
      (let* ([u-p-r (unit-prop-rem l x)]
             [b-s-upr (basic-step u-p-r assign2 xyz2) ])
        (cond[(equal? #t (car b-s-upr)) (begin (set! assign (cadr b-s-upr))
                                               #t)]
             [(equal? #f (car b-s-upr)) (let* ([u-p-r-2 (unit-prop-rem l (* -1 x))]
                                               [b-s-upr-2 (basic-step u-p-r-2 assign3 xyz3)])
                                          (cond[(equal? #t (car b-s-upr-2)) (begin (set! assign (cadr b-s-upr-2))
                                                                                   #t)]
                                               [(equal? #f (car b-s-upr-2)) #f]
                                               [else (let* ([car3 (abs (car (caddr b-s-upr-2)))]
                                                            [if-fails (begin (set! xyz3 (remove* (list car3 (* -1 car3)) (caddr b-s-upr-2)))
                                                                             (dpll-h (caar b-s-upr-2) (cadr b-s-upr-2) xyz3 car3))])
                                                       (cond[if-fails #t]
                                                            [else #f]))]))]
             [else (let* ([car2 (abs (car (caddr b-s-upr)))]
                          [if-fails-1 (begin (set! xyz2 (remove* (list car2 (* -1 car2)) (caddr b-s-upr)))
                                             (dpll-h (caar b-s-upr) (cadr b-s-upr) xyz2 car2))])
                     (cond [if-fails-1 #t]
                           [else (let* ([u-p-r-2 (unit-prop-rem l (* -1 x))]
                                        [b-s-upr-2 (basic-step u-p-r-2 assign3 xyz3)])
                                   (cond[(equal? #t (car b-s-upr-2)) (begin (set! assign (cadr b-s-upr-2))
                                                                            #t)]
                                        [(equal? #f (car b-s-upr-2)) #f]
                                        [else (let* ([car3 (abs (car (caddr b-s-upr-2)))]
                                                     [if-fails (begin (set! xyz3 (remove* (list car3 (* -1 car3)) (caddr b-s-upr-2)))
                                                                      (dpll-h (caar b-s-upr-2) (cadr b-s-upr-2) xyz3 car3))])
                                                (cond[if-fails #t]
                                                     [else #f]))]))]))])))
    
    
    (let* ([car-o (abs (car xyz))]
           [if-f-o (begin (set! xyz (remove* (list car-o (* -1 car-o)) xyz))
                          (dpll-h t-l-f assign-my xyz car-o))])
      (cond [if-f-o #t]
            [else #f]))))

















